//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "MainCode.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

TMainForm *MainForm;    //   

        int N;                          // 
        float A[10][10],B[10],C[10],U,Y,Yout;//   
        float X[10],dX[10];             //  
        float dt;                       // 

//     - -, .. 
void Derive(float *Xl, float *dXl){
        int i,j;
        for(i=0;i<N;i++){               //     
         dXl[i]=0;                      // -
         for(j=0;j<N;j++)               //   
          dXl[i]=dXl[i]+A[i][j]*Xl[j]; //   A*X
         dXl[i]=dXl[i]+B[i]*U;         //  dX=A*X+B*U
        }
}

// 
void Euler(){
        int i;
        for(i=0;i<N;i++) X[i]=X[i]+dX[i]*dt;
}

//  
void EulerModif(){
        int i;
        float X1[10],dX1[10];
        for(i=0;i<N;i++) X1[i]=X[i]+dX[i]*dt;
        Derive(X1,dX1);
        for(i=0;i<N;i++) X[i]=X[i]+1.0/2*(dX[i]+dX1[i])*dt;
}

//  
void EulerAdvan(){
        int i;
        float X12[10],dX12[10];
        for(i=0;i<N;i++) X12[i]=X[i]+dX[i]*dt/2;
        Derive(X12,dX12);
        for(i=0;i<N;i++) X[i]=X[i]+dX12[i]*dt;
}

// - 4- 
void RungeKutta4(){
        int i;
        float k1[10],k2[10],k3[10],k4[10],Xl[10];
        Derive(X,k1);  for(i=0;i<N;i++) k1[i]=k1[i]*dt; // k1
        for(i=0;i<N;i++) Xl[i]=X[i]+k1[i]/2;  //   k2
        Derive(Xl,k2); for(i=0;i<N;i++) k2[i]=k2[i]*dt; // k2
        for(i=0;i<N;i++) Xl[i]=X[i]+k2[i]/2;  //   k3
        Derive(Xl,k3); for(i=0;i<N;i++) k3[i]=k3[i]*dt; // k3
        for(i=0;i<N;i++) Xl[i]=X[i]+k3[i];    //   k4
        Derive(Xl,k4); for(i=0;i<N;i++) k4[i]=k4[i]*dt; // k4
        // Xi+1
        for(i=0;i<N;i++) X[i]=X[i]+1.0/6*(k1[i]+2*k2[i]+2*k3[i]+k4[i]);
}

//---------------------------------------------------------------------------
//  TMainForm
__fastcall TMainForm::TMainForm(TComponent* Owner)
        : TForm(Owner)
{
        //  
        StringGrid2->Cells[0][0]="";
        StringGrid2->Cells[1][0]="";
        StringGrid2->Cells[0][1]="";
        StringGrid2->Cells[0][2]="";
        StringGrid2->Cells[0][3]="Y";
        ComboBox1->ItemIndex=1;
}

//---------------------------------------------------------------------------
//   " "
void __fastcall TMainForm::Button1Click(TObject *Sender)
{
        float t;      // 
        float tme;    // 
        float qt;     //  
        float Yst;    // ,  
                      //   ,  
        int i,j,m;    //
        // ,    
        //
        AnsiString str;
        char *ch,buf[80];
        strstream inbuf(buf, sizeof (buf) , ios::in | ios::out);
        TDateTime TSolve;
        int Metod;
        Metod=ComboBox1->ItemIndex;
        //   (   )
        if (StringGrid2->Cells[1][1]=="") StringGrid2->Cells[1][1]="0,001";
        if (StringGrid2->Cells[1][2]=="") StringGrid2->Cells[1][2]="10";
        if (StringGrid2->Cells[1][3]=="") StringGrid2->Cells[1][3]="0,5";
        if (StringGrid2->Cells[1][4]=="") StringGrid2->Cells[1][4]="3";
        dt=StrToFloat(StringGrid2->Cells[1][1]);
        t=StrToFloat(StringGrid2->Cells[1][2]);
        Yst=StrToFloat(StringGrid2->Cells[1][3]);
        N=StrToFloat(StringGrid2->Cells[1][4]);
        //       
        N=Memo1->Lines->Count;
        //   
        for(i=0;i<N;i++){X[i]=0;dX[i]=0;}tme=0;
        //  
        for(i=0;i<N;i++){
         //      inbuf
         inbuf.seekp(0);
         //   -  ,   
         // Memo1    inbuf
         inbuf<<Memo1->Lines->Strings[i].c_str()<<" Sasha "<<flush;
         //      inbuf
         inbuf.seekg(0);
         //      
         for(j=0;j<N;j++) inbuf>>A[i][j];
        }
        //  B
        inbuf.seekp(0);
        inbuf<<Edit1->Text.c_str()<<" Sasha ";
        inbuf.seekg(0);
        for(j=0;j<N;j++) inbuf>>B[j];
        //  
        inbuf.seekp(0);
        inbuf<<Edit3->Text.c_str()<<" Sasha ";
        inbuf.seekg(0);
        for(j=0;j<N;j++) inbuf>>C[j];
        //  U
        inbuf.seekp(0);
        inbuf<<Edit2->Text.c_str()<<" Sasha ";
        inbuf.seekg(0);
        inbuf>>U;
        // 
        for(i=0;i<4;i++) Chart->Series[i]->Clear();
        //    1000   
        m=t/(dt*1000);
        if (m==0) m=1;
        // 
        TSolve=Time();
        while (tme<t){
         switch(Metod){
          case 0: Euler();break;
          case 1: EulerModif();break;
          case 2: EulerAdvan();break;
          case 3: RungeKutta4();}
         Derive(X,dX);
         //  
         Y=0; for(j=0;j<N;j++) Y=Y+X[j]*C[j];
         //   
         i++; if (!(i%m)) Chart->Series[0]->AddXY(tme,Y,"",clGreen);
         //   
         if ((Y<Yst*0.95)|(Y>Yst*1.05)) qt=tme;
         //     
         tme=tme+dt;
        }
        TSolve=Time()-TSolve;
        Label1->Caption=" : "+FormatDateTime("s,z ",TSolve);
        //    ymax,ymin   - 
        Chart->Series[1]->AddXY(0,Yst*1.05,"",clRed);
        Chart->Series[1]->AddXY(t,Yst*1.05,"",clRed);
        Chart->Series[2]->AddXY(0,Yst*0.95,"",clRed);
        Chart->Series[2]->AddXY(t,Yst*0.95,"",clRed);
        Chart->Series[3]->AddXY(qt,0,"",clBlue);
        Chart->Series[3]->AddXY(qt,Yst*1.05,"",clBlue);
        //     
        if (abs(t-qt)<=dt*10) str=" / -   ";
        else  str=" /="+FloatToStrF(qt,ffFixed,5,4)+" ";
        Chart->Title->Text->Strings[1]=str;
}
//---------------------------------------------------------------------------

//    
void __fastcall TMainForm::StringGrid1KeyPress(TObject *Sender, char &Key)
{
        if (Key=='.') Key=',';
        if (((Key<'0')|(Key>'9'))&(Key!=',')&(Key!=8)) Key=0;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::StringGrid2KeyPress(TObject *Sender, char &Key)
{
        if (Key=='.') Key=',';
        if (((Key<'0')|(Key>'9'))&(Key!=',')&(Key!=8)) Key=0;
}
//---------------------------------------------------------------------------
//     
void __fastcall TMainForm::ChartContextPopup(TObject *Sender,
      TPoint &MousePos, bool &Handled)
{
        PopupMenu->Popup(MousePos.x+MainForm->Left,MousePos.y+MainForm->Top);
}
//---------------------------------------------------------------------------
//       
void __fastcall TMainForm::N1Click(TObject *Sender)
{
        Chart->CopyToClipboardBitmap();
}
//---------------------------------------------------------------------------


