//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "difint.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)

//  TDifInt    - -

// 
float TDifInt::Euler(TDifParam *dp){
        xout=xout+Deriv(xout,dp->t)*dp->dt;
        return(xout);
}

//  
float TDifInt::EulerModif(TDifParam *dp){
        float xout1;
        xout1=xout+Deriv(xout,dp->t)*dp->dt;
        xout=xout+1.0/2*(Deriv(xout,dp->t)+Deriv(xout1,dp->t+dp->dt))*dp->dt;
        return(xout);
}

//  
float TDifInt::EulerAdvan(TDifParam *dp){
        float xout12;
        xout12=xout+Deriv(xout,dp->t)*dp->dt/2;
        xout=xout+Deriv(xout12,dp->t+dp->dt/2)*dp->dt;
        return(xout);
}

// - 4- 
float TDifInt::RungeKutta4(TDifParam *dp){
        float k1,k2,k3,k4;
        k1=Deriv(xout,dp->t)*dp->dt;
        k2=Deriv(xout+k1/2,dp->t+dp->dt/2)*dp->dt;
        k3=Deriv(xout+k2/2,dp->t+dp->dt/2)*dp->dt;
        k4=Deriv(xout+k3,dp->t+dp->dt)*dp->dt;
        xout=xout+1.0/6*(k1+2*k2+2*k3+k4);
        return(xout);
}

//   .     
//
float TDifInt::Deriv(float xout,float t){
        return(0);
}




